<template>
	<v-card elevation="20">
		<v-card-title>Datos personales</v-card-title>
		<v-form>
			<v-card-text>
				<v-row>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							:disabled="update"
							prepend-icon="fas fa-address-card"
							label="Nombre"
							:rules="ruleNames"
							outlined
							v-model="personalData.name"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							:disabled="update"
							prepend-icon="fas fa-address-card"
							label="Apellido paterno"
							:rules="ruleNames"
							outlined
							v-model="personalData.fstSurname"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							:disabled="update"
							prepend-icon="fas fa-address-card"
							label="Apellido materno"
							:rules="ruleNames"
							outlined
							v-model="personalData.sndSurname"
							required
						/>
					</v-col>
				</v-row>
				<v-row justify="space-around">
					<v-col cols="12" sm="3">
						<v-text-field
							:disabled="update"
							prepend-icon="fas fa-sort-numeric-up"
							label="Edad"
							:rules="rulesAge"
							outlined
							min="0"
							type="number"
							suffix="años"
							v-model="personalData.age"
							required
						/>
					</v-col>
					<v-col cols="12" sm="3">
						<p slot="label" class="headline">Selecciona un género</p>
						<v-radio-group
							:disabled="update"
							v-model="personalData.gender"
							mandatory
							row
							prepend-icon="fa-venus-mars"
							:rules="ruleRequired"
						>
							<v-radio label="Hombre" value="Hombre" color="blue" />
							<v-radio label="Mujer" value="Mujer" color="blue" />
						</v-radio-group>
					</v-col>
					<v-col cols="12" sm="3">
						<p slot="label" class="headline">¿Perteneces a un grupo étnico?</p>
						<v-radio-group
							:disabled="update"
							v-model="ethnicGroup"
							mandatory
							row
							prepend-icon="fa-user-friends"
							:rules="ruleRequired"
						>
							<v-radio label="Si" value="Si" color="blue" />
							<v-radio label="No" value="No" color="blue" />
						</v-radio-group>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify="center" justify-sm="end">
					<v-col cols="12" sm="3" v-if="update">
						<v-btn block outlined color="orange" @click="update = !update">Modificar</v-btn>
					</v-col>
					<v-col cols="12" sm="3" v-else>
						<v-btn block outlined color="red" @click="cancelUpdate">Cancelar</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="update" block outlined :loading="loading" color="green" @click="updateData">
							Actualizar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-form>
	</v-card>
</template>

<script>
import gql from "graphql-tag";
import { mapState, mapMutations } from "vuex";

export default {
	name: "ProfilePersonalData",
	data: () => ({
		update: true,
		loading: false,
		ethnicGroup: "No",
		personalData: {
			name: "",
			fstSurname: "",
			sndSurname: "",
			age: "",
			gender: "Hombre",
			ethnicGroup: Boolean
		},
		ruleRequired: [value => !!value || "Campo requerido"],
		ruleNames: [
			value => !!value || "Campo requerido",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'"1234567890,<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo permitidas letras";
			}
		],
		rulesAge: [
			value => !!value || "Campo requerido",
			value => (value >= 15 && value <= 50) || "Tienes que ser estudiante"
		],
		rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
		rulesEmail: [
			value => !!value || "Campo requerido",
			value => {
				const pattern = /^\w+([\.-]?\w+)*@\w+(\.com||\.com\.mx||\.mx||\.es||\.uaz||\.edu\.mx||\.utzac\.edu\.mx)+$/;
				return pattern.test(value) || "Correo electrónico inválido";
			}
		]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		// Obtiene los datos personales y llena los inputs
		async getData() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								personalData {
									name
									fstSurname
									sndSurname
									age
									gender
									ethnicGroup
								}
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.personalData.name = data.findStudent.personalData.name;
				this.personalData.fstSurname =
					data.findStudent.personalData.fstSurname;
				this.personalData.sndSurname =
					data.findStudent.personalData.sndSurname;
				this.personalData.age = data.findStudent.personalData.age;
				this.personalData.gender = data.findStudent.personalData.gender;
				data.findStudent.personalData.ethnicGroup
					? (this.ethnicGroup = "Si")
					: (this.ethnicGroup = "No");
			} catch (error) {}
		},
		// primera letra mayúscula
		capitalLetter(name){
			name = name.split(" ");

    		for (var i = 0, x = name.length; i < x; i++) {
    		    name[i] = name[i][0].toUpperCase() + name[i].substr(1);
    		}

    		return name.join(" ");
		},
		// Cancela las modificaciones
		cancelUpdate() {
			this.getData();
			this.update = !this.update;
		},
		// Actualiza los datos personales
		async updateData() {
			this.personalData.name = this.capitalLetter(this.personalData.name);
			this.personalData.fstSurname = this.capitalLetter(this.personalData.fstSurname);
			this.personalData.sndSurname = this.capitalLetter(this.personalData.sndSurname);
			this.ethnicGroup === "Si"
				? (this.personalData.ethnicGroup = true)
				: (this.personalData.ethnicGroup = false);
			this.personalData.age = parseInt(this.personalData.age, 10);
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$name: String!
							$fstSurname: String!
							$sndSurname: String!
							$gender: String!
							$ethnicGroup: Boolean!
							$age: Int!
						) {
							addUpdatePersonalData(
								name: $name
								fstSurname: $fstSurname
								sndSurname: $sndSurname
								gender: $gender
								ethnicGroup: $ethnicGroup
								age: $age
							)
						}
					`,
					variables: {
						name: this.personalData.name,
						fstSurname: this.personalData.fstSurname,
						sndSurname: this.personalData.sndSurname,
						gender: this.personalData.gender,
						ethnicGroup: this.personalData.ethnicGroup,
						age: this.personalData.age
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.update = true;
				}, 1500);
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.getData();
	}
};
</script>

<style scope>
#cap{
	text-transform: capitalize;
}
</style>